<?php

    class Shell_Script_Evaluation_Action extends Reactor_Action
    {
        protected $tpl = 'shell_script_evaluation.php';
        protected $name = 'Run a shell script';
		
		public static $registration = array(
			ACTION_NAME => 'Run a shell script',
			ACTION_CATEGORY => 'Code Evaluation',
			ACTION_DESCRIPTION => 'Evaluate the returned output from a designated shell script.',
			ACTION_AUTHOR => 'Jeremy Yunis, Nagios Enterprises, LLC',
			ACTION_VERSION => '1.0',
			ACTION_DATE => '01/22/2013', //Last version update
			ACTION_AUTHLEVEL => 0,  // 0 - everyone | 1 - Admin only
			ACTION_TYPE => 'core', //core | user. core modules can't be deleted
			ACTION_META => array(),	//Misc information	
		); 		
		
        protected $fields = array(
            'script' => array(
                'label' => 'shell script',
                'validate' => 'trim|required'
            ),
        );

        public function run($context)
        {
            $this->set_context($context);
            $params = $this->get_params();
            $script = $params['script'];
            list($cmd_out_arr, $cmd_status) = do_eval_sh($script);
            $cmd_out = implode("\n", $cmd_out_arr);
            $this->log('info', "got output: ".$cmd_out);
            $this->log('info', "cmd exit status: ".$cmd_status);
            $this->set_result($cmd_status);
            return $context;
        }
    }
